import java.util.*;
import g5.rep.*;
import g5.meta.t.*;
import g5.DataGrid;
import g5.qry.*;
import g5.gqry.*;
import g5.meta.*;
import g5.secure.*;

public class CustomizedSort2 implements Comparator<String> {
   /**
    * Constructor.
    */
   public CustomizedSort2() throws Exception {
   	AssetRef ref = Query.getAssetRef(query, qType);
      Query qry = (Query) QueryRep.get().getAsset(ref, null);
      GPrincipal user = null;
      QContext ctxt = new QContextImpl(null, user);
      QCol[] cols = qry.cols(false);
      QCol qcol = null;
      GDimCol dcol1 = null;
      GDimCol dcol2 = null;
   
      for(QCol col : cols) {
         if(col1.equals(col.getView()) || col1.equals(col.getID())) {
            qcol = col;
            dcol1 = new GDimCol(qcol);
         }
         if(col2.equals(col.getView()) || col2.equals(col.getID())) {
            qcol = col;
            dcol2 = new GDimCol(qcol);
         }
      }
      
      GTotalInfo tinfo = new GTotalInfo(new GDimCol[]{dcol1, dcol2}, new GMeasureCol[0]);
      GQuery gqry = GQuery.create(qry, ctxt, cols, tinfo, null, null, null);
      DataGrid grid = gqry.getGrid();

      int size = grid.size(0);
      
      if(size < 0) {
         System.out.println(" -------------- " + size);
         return;
      }
      
      String[] cols1 = new String[size];
      String[] cols2 = new String[size];
      
      for(int i = 1; i < size; i++){
         cols1[i] = (String) grid.get(i, 0);
         cols2[i] = "" +  grid.get(i, 1);
      }
      
      list1 = Arrays.asList(cols1);
      list2 = Arrays.asList(cols2);
   }
   
   @Override
   public int compare(String o1, String o2) {
      int idx1 = list1.indexOf(o1);
      int idx2 = list1.indexOf(o2);
      String v1 = list2.get(idx1);
      String v2 = list2.get(idx2);
      return v1.compareTo(v2);
   }

   private List<String> list1, list2;
   private String col1 = "产品名称";
   private String col2 = "利润";
   private String query = "定制排序";
   private String qType = ".sqry";
}
